# Copyright (C) 2017 McAfee, Inc. All rights reserved.
# Cookbook Name:: Cloud-Workload-Security
# Script:: Use this ruby file to encrypt the Mvision username and password. This will create a data bag epo_credentials and encrypted_data_bag_secret key.

require "securerandom"
require "json"

username = ARGV[0]
password = ARGV[1]
env=ARGV[2]  # Environment URL   
#Creating the encryption key
File.open("files/encrypted_data_bag_secret","wb") { |file|  
  file.write(SecureRandom.base64(512))
}

#Creating a knife data bag.
output  = `knife data bag create mvision_cloud_credentials`
if !output.strip == "Created data_bag[mvision_cloud_credentials]"
  puts "Failed to create data bag password with error : #{output}"
end

File.open("temp.json", "w") do |file|
  cred_map = {"id" => "credentials", "username" => username, "password" => password,"env"=>env}
  file.write(JSON.dump(cred_map))
end

system "knife data bag from file mvision_cloud_credentials temp.json --secret-file files/encrypted_data_bag_secret"
File.delete("temp.json")
