# Copyright (C) 2017 McAfee, Inc. All rights reserved.
# Cookbook Name:: Cloud-Workload-Security
# Library:: Helper module required for default recipe.rb
#
# *********************************************************************
# * Helper module for default recipe.rb
# *********************************************************************
require 'openssl'
require 'open-uri'
require 'rexml/document'
require 'socket'
require 'net/http'
require 'json'
require 'base64'

module McApicall
	# method to call various mcafee cws api
	def call_mc_api(first_argument,second_argument)
		url_api="#{first_argument}"
		jsontype="#{second_argument}"
		uri = URI(url_api)
		Net::HTTP.start(uri.host, uri.port,
										:use_ssl => uri.scheme == 'https',
										:verify_mode => OpenSSL::SSL::VERIFY_NONE
		) do |http|
			request = Net::HTTP::Get.new uri
			request.basic_auth "#{node[:mvc][:username]}","#{node[:mvc][:password]}"
			http.request request do |response|
				if (jsontype=="jsonformat")
					@arr_call_response=JSON.parse(response.body)
					return @arr_call_response
				else
					@arr_call_response=response.body
					return @arr_call_response
				end
			end
		end
	end

	def call_mvc_api(first_argument,second_argument,header)
		url_api="#{first_argument}"
		jsontype="#{second_argument}"

		uri = URI(url_api)
		username= header['username']
		password= header['password']

		Net::HTTP.start(uri.host, uri.port,
										:use_ssl => uri.scheme == 'https',
										:verify_mode => OpenSSL::SSL::VERIFY_NONE
		) do |http|
			request = Net::HTTP::Get.new uri
			request.basic_auth username,password
			http.request request do |response|
				if (jsontype=="jsonformat")
					@arr_call_response=JSON.parse(response.body)
					return @arr_call_response
				else
					@arr_call_response=response.body
					return @arr_call_response
				end
			end
		end
	end

	module_function :call_mvc_api

	def getMetadataRequest(first_argument)
		begin
			ret=1
			url_meta="#{first_argument}"
			uri = URI(url_meta)
			req = Net::HTTP::Get.new(uri.request_uri)
			req['Metadata'] = "true"
			res = Net::HTTP.start(uri.hostname, uri.port) {|http|  http.request(req)}
			if (res.code =="200"||"404")
				return res
			else
				return ret
			end
		rescue SystemCallError, StandardError
			#Creating a mock Response object to bring uniformity.
			response = Net::HTTPResponse.new "1.1", "404", "Couldn't connect"
			return response
		end
	end



	def getMAInstallUrlFromServer(entity_id)
		mvision_cloud_secret = Chef::EncryptedDataBagItem.load_secret("#{File.dirname(__FILE__).split("libraries")[0]}files/encrypted_data_bag_secret")
		mvision_cloud_creds = Chef::EncryptedDataBagItem.load("mvision_cloud_credentials", "credentials", mvision_cloud_secret)
		username = mvision_cloud_creds['username']
		password = mvision_cloud_creds['password']
		env= mvision_cloud_creds['env']
		keyfilepath=File.expand_path(File.dirname(File.dirname(__FILE__)))+"/files"
		directory "#{keyfilepath}" do
			recursive true
			action :delete
		end
		mcafeeagenturl=""
		header=Hash["username" => username,"password"=> password]
		getMA_url=env+"/shnapi/rest/external/api/v2/iaas/getMAInstallURL?cspInstanceId="+entity_id
		mcafeeagenturlResponse=McApicall.call_mvc_api(getMA_url,"jsonformat",header)
		agenturl=mcafeeagenturlResponse["url"]
		tokenValue=agenturl.split("=")[1]
		agenturl=agenturl.split("/ComputerMgmt");
		mcafeeagenturl=agenturl[0]+"/ComputerMgmt/agentPackageDownload/McAfeeSmartInstall.download?token="+tokenValue
		return mcafeeagenturl;
	end


end

Chef::Recipe.include(McApicall)
Chef::Resource.include(McApicall)